﻿using System;
using System.Collections.Generic;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Shapes;

namespace SigmaFilter3x3
{ public partial class MainPage:UserControl 
  { const Int32 xSize = 11, ySize = 12;
    Double dx, dy;
    Byte[,] image0, image1, image2; // original-, noisy-, filtered-image
    Rectangle[,] bigPixels; 
    List<SolidColorBrush> ShadesOfGray = new List<SolidColorBrush>();
    Random random = new Random();
    public MainPage() 
    { InitializeComponent();
      for ( UInt16 i=0; i <= 255; i++ ) //create 256 brushes
        ShadesOfGray.Add( new SolidColorBrush( Color.FromArgb( 255, (Byte)i, (Byte)i, (Byte)i ) ) );
      /*image = new Byte[,] { {  0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0},
                             {  0,   0,   0,   0, 200, 200, 200,   0,   0,   0,   0},
                             {  0,   0,   0, 150, 200, 100, 200, 150,   0,   0,   0},
                             {  0,   0,   0,   0, 200, 200, 200,   0,   0,   0,   0},
                             {  0,   0,   0,   0,   0, 200,   0,   0,   0,   0,   0},
                             {100, 150, 200, 200, 200, 200, 200, 200, 200, 150, 100},
                             {  0,   0,   0,   0, 200, 200, 200,   0,   0,   0,   0},
                             {  0,   0,   0,   0, 200, 200, 200,   0,   0,   0,   0},
                             {  0,   0,   0,   0, 200,   0, 200,   0,   0,   0,   0},
                             {  0,   0,   0,   0, 200,   0, 200,   0,   0,   0,   0},
                             {  0,   0,   0,   0, 200,   0, 200,   0,   0,   0,   0},
                             {  0,   0,   0, 100, 100,   0, 100, 100,   0,   0,   0} };*/
      image0 = new Byte[,] { {  0,   0,   0,   0,   0,   0,   0,   0,   0,   0, 255},
                             {  0,   0,   0,   0,   0,   0,   0,   0,   0, 255, 255},
                             {  0,   0,   0,   0,   0,   0,   0,   0, 255, 255, 255},
                             {  0,   0,   0,   0,   0,   0,   0, 255, 255, 255, 255},
                             {  0,   0,   0,   0,   0,   0, 255, 255, 255, 255, 255},
                             {  0,   0,   0,   0,   0, 255, 255, 255, 255, 255, 255},
                             {  0,   0,   0,   0, 255, 255, 255, 255, 255, 255, 255},
                             {  0,   0,   0, 255, 255, 255, 255, 255, 255, 255, 255},
                             {  0,   0, 255, 255, 255, 255, 255, 255, 255, 255, 255},
                             {  0, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255},
                             {255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255},
                             {255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255} };

      image1 = new Byte[ySize,xSize];
      image2 = new Byte[ySize,xSize];
      bigPixels = new Rectangle[ySize,xSize];
    }

    private void canvas_Loaded( object sender, RoutedEventArgs e ) 
    { dx = DrawCanvas.Width / xSize; //pixel width
      dy = DrawCanvas.Height/ ySize; //pixel height
      //Fill the drawing area with rectangles which should represent pixels
      for ( int y=0; y < ySize; y++ )
        for ( int x=0; x < xSize; x++ ) 
        { Rectangle r = bigPixels[y,x] = new Rectangle();
          r.Width  = dx-1;  
          r.Height = dy-1;
          Canvas.SetLeft( r, x*dx ); //x-position
          Canvas.SetTop ( r, y*dy ); //y-position
          DrawCanvas.Children.Add( r );
        }
      for ( int y=0; y < ySize; y++ )
        for ( int x=0; x < xSize; x++ )
          image1[y,x] = image0[y,x]; //copy input to noisy image
      drawPixels( image1 );          //show noisy image
    }

    private void filter( int sigma ) 
    { int midPixel, anyPixel, sum, no, x, xx, xxx, y, yy, yyy;
      for ( y=0; y < ySize; y++ ) //=============
      { for ( x=0; x < xSize; x++ ) //===========
        { midPixel = image1[y,x];
          sum = no = 0;
          for ( yy=-1; yy <= 1; yy++ ) //==========
          { yyy = y + yy;
            if ( yyy < 0 | yyy >= ySize ) continue;   //beyond the border
            for ( xx=-1; xx <= 1; xx++ )//=========
            { xxx = xx + x;
              if ( xxx < 0 | xxx >= xSize ) continue; //beyond the border
              anyPixel = image1[yyy,xxx];
              if ( Math.Abs( midPixel - anyPixel ) < sigma )
              { sum += anyPixel; no++; }
            } //====== end for (int xx... ================
          } //======== end for (int yy... ================
          if ( no > 0 ) image2[y,x] = Convert.ToByte( (float)sum / no );
          else          image2[y,x] = (Byte)midPixel; //just copy
        } //============ end for (int x... =====================
      } //============== end for (int y... =====================
    } // end of private void filter(...)

    private void drawPixels( Byte[,]  image )
    { for ( int y=0; y < ySize; y++ )
        for ( int x=0; x < xSize; x++ )  
          bigPixels[y,x].Fill = ShadesOfGray[image[y,x]]; //fill them with monchrome gray
    }
    private void MoreNoise_Click( object sender, RoutedEventArgs e ) 
    { for ( int y=0; y < ySize; y++ )
        for ( int x=0; x < xSize; x++ ) 
        { int gray = image1[y,x] + random.Next(20);
          if ( gray > 255 ) image1[y,x] -= 20; //too bright
          else              image1[y,x] = (Byte)gray;
        }
      drawPixels( image1 );
      slider.Value = 0;
      sigmaTextBox.Text = "0"; 
    } 

    private void RemoveNoise_Click( object sender, RoutedEventArgs e ) 
    { for ( int y=0; y < ySize; y++ )
        for ( int x=0; x < xSize; x++ )
          image1[y,x] = image0[y,x]; //reload the original input image
      drawPixels( image1 );          //show it
      slider.Value = 0;
      sigmaTextBox.Text = "0"; 
    } 

    private void slider_MouseLeftButtonUp(object sender,MouseButtonEventArgs e)
    { int sigma = Convert.ToInt32( slider.Value ); //get sigma from the slider
      sigmaTextBox.Text = sigma.ToString();        //show it in the TextBox
      filter( sigma );                             //call the sigma filter
      drawPixels( image2 );                        //show the filtered image
    } // end of private void slider_MouseLeftButtonUp(...)
  } // end of public partial class MainPage:UserControl
} // end of namespace
